{% extends "layouts/page.html" %}{% load static %}
{% block page %}
{% static "/media/images/timetable.webp" as image %}
{% include "layouts/showcase.html" with image=image title=_("Prayer timetable") %}
<div class="max-w-screen-xl mx-auto px-8 py-14">

  {% comment %} TIMETABLE TITLE {% endcomment %}
  <div
    data-aos="zoom-out-up"
    data-aos-duration="1000"
    class="text-2xl px-3 py-1 text-center"
  >
    {{table_title}}
  </div>

  {% comment %} MONTHS PANEL {% endcomment %}
  <ul
    data-aos="zoom-out-up"
    data-aos-duration="1000"
    class="relative grid grid-cols-[repeat(12,minmax(5.5rem,1fr))] items-center gap-2.5 my-2 p-2 text-sm rounded-md shadow-lg overflow-x-auto bg-gradient-to-br from-main/95 to-main-dark"
  >
    {% for month in months %}
    <li
      data-aos="zoom-in"
      data-aos-duration="1000"
      data-aos-delay="{{forloop.counter0}}00"
    >
      <a
        href="?month={{forloop.counter}}"
        title="{{month}}"
        class="flex justify-center items-center px-2 h-8 font-medium whitespace-nowrap text-main-darken rounded shadow-lg transition-all hover:bg-main-dark {% if forloop.counter != month_num %} bg-gradient-to-br from-white to-main-white {% else %} bg-gradient-to-br from-accent-light to-accent-dark {% endif %} hover:from-main-dark hover:to-main hover:text-white"
      >
        {{month}}
      </a>
    </li>
    {% endfor %}
  </ul>

  {% comment %} TIMETABLE TABLE {% endcomment %}
  <div
    id="tableBox"
    data-aos="zoom-out-up"
    data-aos-duration="1000"
    class="relative w-full max-h-[32rem] bg-white/50 rounded-md shadow-lg overflow-auto scroll-smooth"
  >
    <table id="table" class="w-full whitespace-nowrap">
      <thead
        id="tableHead"
        class="sticky top-0 z-10 text-left text-main-white bg-gradient-to-br from-main/95 to-main-dark"
      >
        <tr class="shadow-md">
          <th class="p-3">
            <span class="flex gap-2 items-baseline">
              <i class="fa-solid fa-calendar-days text-accent"></i>
              <span>
                {{_("Date")}}
              </span>
            </span>
          </th>
          <th class="p-3">
            <span class="flex gap-2 items-baseline">
              <i class="fa-solid fa-calendar-day text-accent"></i>
              <span>
                {{_("Day of the week")}}
              </span>
            </span>
          </th>
          <th class="p-3">
            <span class="flex gap-2 items-baseline">
              <i class="fa-solid fa-clock text-accent"></i>
              <span>
                {{_("Fajr")}}
              </span>
            </span>
          </th>
          <th class="p-3">
            <span class="flex gap-2 items-baseline">
              <i class="fa-solid fa-clock text-accent"></i>
              <span>
                {{_("Sunrise")}}
              </span>
            </span>
          </th>
          <th class="p-3">
            <span class="flex gap-2 items-baseline">
              <i class="fa-solid fa-clock text-accent"></i>
              <span>
                {{_("Dhuhr")}}
              </span>
            </span>
          </th>
          <th class="p-3">
            <span class="flex gap-2 items-baseline">
              <i class="fa-solid fa-clock text-accent"></i>
              <span>
                {{_("Asr")}}
              </span>
            </span>
          </th>
          <th class="p-3">
            <span class="flex gap-2 items-baseline">
              <i class="fa-solid fa-clock text-accent"></i>
              <span>
                {{_("Maghrib")}}
              </span>
            </span>
          </th>
          <th class="p-3">
            <span class="flex gap-2 items-baseline">
              <i class="fa-solid fa-clock text-accent"></i>
              <span>
                {{_("Isha'a")}}
              </span>
            </span>
          </th>
        </tr>
      </thead>
      <tbody>
        {% now "Y-m-d" as today %}
        {% for time in timetable %}
        <tr
          class="
          {% if time.date|date:'Y-m-d' < today %}
          even:bg-main-white opacity-50
          {% elif time.date|date:'Y-m-d' > today %}
          even:bg-main-white
          {% else %}
          bg-gradient-to-br from-accent/70 to-accent-dark/90 relative shadow-md font-medium today-row
          {% endif %}
        ">
          <td class="p-2.5">{{time.date|date:"F, j"}}</td>
          <td class="p-2.5">{{time.date|date:"l"}}</td>
          <td class="p-2.5">{{time.fajr|time:"H : i"}}</td>
          <td class="p-2.5">{{time.sunrise|time:"H : i"}}</td>
          <td class="p-2.5">{{time.dhuhr|time:"H : i"}}</td>
          <td class="p-2.5">{{time.asr|time:"H : i"}}</td>
          <td class="p-2.5">{{time.maghrib|time:"H : i"}}</td>
          <td class="p-2.5">{{time.isha|time:"H : i"}}</td>
        </tr>
        {% endfor %}
      </tbody>
    </table>
  </div>

  {% comment %} PDF GENERATOR {% endcomment %}
  <div class="flex justify-end py-4">
    <button
      data-aos="zoom-in-right"
      data-aos-duration="1000"
      data-aos-anchor-placement="top-bottom"
      id="pdfDownloader"
      class="inline-flex items-center gap-2 h-8 px-6 text-white text-xs font-medium rounded shadow-lg whitespace-nowrap bg-gradient-to-br from-main/95 to-main-dark hover:bg-gradient-to-tl"
    >
      <i class="fa-solid fa-file-pdf"></i>
      <span>Download PDF</span>
    </button>
  </div>
</div>

<script>
  document.addEventListener("DOMContentLoaded", () => {
    const tableBox = document.getElementById("tableBox");
    const tableHead = document.getElementById("tableHead");
    const todayRow = document.getElementsByClassName("today-row")[0];
    const pdfDownloader = document.getElementById("pdfDownloader");
    const pdfIconClassNames = ["fa-file-pdf", "fa-spinner", "animate-spin"];
    const pdfDownloaderIcon = document
      .getElementById("pdfDownloader")
      .querySelector("i").classList;

    todayRow &&
      setTimeout(() => {
        tableBox.scrollTop = todayRow.offsetTop - tableHead.offsetHeight;
      }, 1000);

    pdfDownloader.addEventListener("click", () => {
      pdfDownloader.classList.toggle("pointer-events-none");
      pdfIconClassNames.forEach((className) =>
        pdfDownloaderIcon.toggle(className)
      );

      const xhr = new XMLHttpRequest();

      xhr.onload = function () {
        if (this.status == 200) {
          const blob = new Blob([xhr.response], { type: "application/pdf" });
          const link = document.createElement("a");

          link.href = window.URL.createObjectURL(blob);
          link.download = "{{table_title|striptags}}.pdf".replaceAll(" ", "_");
          link.click();

        } else alert(`Error: ${this.status}`);

        setTimeout(() => {
          pdfDownloader.classList.toggle("pointer-events-none");
          pdfIconClassNames.forEach((className) =>
            pdfDownloaderIcon.toggle(className)
          );
        }, 500)
      };

      try {
        xhr.open("GET", "{% url "apps.timetable:pdf" %}?month={{month_num}}", true);
        xhr.setRequestHeader(
          "Content-type",
          "application/x-www-form-urlencoded"
        );

        xhr.responseType = "blob";
        xhr.send();
      } catch (e) { alert(e) }
    });
  });
</script>
{% endblock page %}